jQuery(function(){
    console.log('admin_init');
    init();
});

function init() {
    if (getUrlParameter('cid') !== '0') {
        console.log(Joomla.JText);
        showLoading();
        jQuery.when(getCounteragents(), getOpf(),getRequestTerminalsDerival()).done(function(){
            hideLoading();
        });
    }
    var findCityKladrBtn = jQuery('<input>',{
        class:'findCityKladr btn btn-primary button-apply btn-success',
        type:'button',
        value: Joomla.JText._('VMSHIPMENT_DELLIN_FIND_KLADR_CITY_BUTTON'),
        on:
            {
                click:function(event){
                    createFindKladrPopup(jQuery(this),'search_city',10);
                }
            }
    });
    var findStreetKladrBtn = jQuery('<input>',{
        class:'findStreetKladr btn btn-primary button-apply btn-success',
        type:'button',
        value: Joomla.JText._('VMSHIPMENT_DELLIN_FIND_KLADR_STREET_BUTTON'),
        on:
            {
                click:function(event){
                    createFindKladrPopup(jQuery(this),'search_street',10);
                }
            }
    });
    jQuery(findCityKladrBtn).insertAfter(jQuery('.cityKladrInput'));
   // jQuery(findStreetKladrBtn).insertAfter(jQuery('.streetKladrInput'));

    jQuery('#params_login,#params_password').change(function () {
        getCounteragents(true);
    });
    jQuery('#params_appkey').change(function () {
        getCounteragents(true);
        checkCounteragent();
        getOpf();
        getRequestTerminalsDerival();
    });
    jQuery('#params_kladr_code_delivery_from').change(function(){
        getRequestTerminalsDerival();
    });
}
function showLoading(){
    hideLoading();
    jQuery('#admin-content').append('<div class="loading-wrap"></div>');
    jQuery('#admin-content').append('<div class="loading"><span class="loading-content"><img src="/plugins/vmshipment/dellin_shipping/image/wait.gif"> '+Joomla.JText._('VMSHIPMENT_DELLIN_PROCESSING')+'</span></div>');
}
function hideLoading(){
    jQuery('.loading-wrap').remove();
    jQuery('.loading').remove();
}

function getUrlParameter(name){
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\?&]cid.+?=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};

function validation(input=false){
    if(!input){
        jQuery('input.error').removeClass('error');
        var iserror = false;
        jQuery('[required]').each(function(){
            if(jQuery(this).val() !== null && jQuery(this).val().length == 0){
                iserror = true;
                console.log(this);
                jQuery(this).addClass('error');
            }
        });
        if(!checkCounteragent()){
            iserror = true;
        }
    }
    else{
        iserror = false;
        if(jQuery(input).val() !== null && jQuery(input).val().length == 0){
            iserror = true;
            if(!jQuery(input).hasClass('error')) jQuery(input).addClass('error');
        }else{
            if(jQuery(input).hasClass('error')) jQuery(input).removeClass('error');
        }
        if(!checkCounteragent()){
            iserror = true;
        }
    }
    console.log(iserror);
    if(iserror){
        return false;
    }
    return true;
}

function getCounteragents(changeSettings){
    var apikey = jQuery('#params_appkey').val();
    var login = jQuery('#params_login').val();
    var password = jQuery('#params_password').val();
    showLoading();
    var data = {'ajax':'y','action':'get_counteragents','login':login,'password':password, 'appkey':apikey,'reset_session':changeSettings};
    return jQuery.ajax({
        url: "/plugins/vmshipment/dellin_shipping/dellin_ajax.php",
        data: data,
        method: "GET",
        dataType: "json"
    }).done(function(response){

        var select = jQuery('<select>',
            {'data-prop_code':'counteragent',
                on:{
                    change:function(event){
                        jQuery(this).siblings('input').attr('value',jQuery(this).val());
                    }
                }
            }
        );
        var options = '';
        if(null !== response.counteragents){
            jQuery.each(response.counteragents,function(id,value){
                var selected = '';
                if(id == jQuery('#params_counteragent').val()){
                    selected = "selected";
                }
                options +='<option '+selected+' value="'+id+'">'+value.name+'</option>';
            });
            jQuery(select).append(options);
        }

        if(jQuery('#params_counteragent').siblings('select').length > 0) {
            jQuery('#params_counteragent').siblings('select').replaceWith(select);
        }else{
            jQuery('#params_counteragent').before(select);
        }
        jQuery('#params_counteragent').val(jQuery('#params_counteragent').siblings('select').val());
        checkCounteragent();
        hideLoading();
    });
}

function checkCounteragent(){
    if(jQuery('#params_login').val().length > 0 && jQuery('#params_password').val().length > 0 && jQuery('#params_appkey').val().length > 0){
        jQuery('#params_counteragent').closest('.control-group').show();
        return true;
    }else{
        jQuery('#params_counteragent').closest('.control-group').hide();
        return false;
    }
}


function getOpf(){
    showLoading();
    jQuery('#params_opf_country,#params_sender_form')
    var apikey = jQuery('#params_appkey').val();
    var data = {'ajax':'y','action':'get_opf','appkey':apikey};
    return jQuery.ajax({
        url: "/plugins/vmshipment/dellin_shipping/dellin_ajax.php",
        data: data,
        method: "GET",
        dataType: "json"
    }).done(function(response){
        if(undefined != response['error'] && jQuery('#params_opf_country').closest('.control-group').find('.error').length == 0){
            jQuery('#params_opf_country').closest('.control-group').find('.control-label').append('<span class="error">'+response['error']+'</span>')
        }else{
            jQuery('#params_opf_country').closest('.control-group').find('.error').remove();
        }
        //страна ОПФ--------------------------------------------------------------
        if(jQuery('#params_opf_country').val() == ""){
            jQuery('#params_opf_country').val('0x8f51001438c4d49511dbd774581edb7a');
        }
        var select = jQuery('<select>',
            {'data-prop_code':'opf_country',
                on:{
                    change:function(event){
                        jQuery(this).siblings('input').val(jQuery(this).val());
                        getOpf();
                    }
                }
            }
        );

        if((response.countries == null || response.countries.length == 0) && jQuery('#params_sender_form').closest('.control-group').find('.error').length == 0){
            jQuery('#params_sender_form').closest('.control-group').find('.control-label').append('<span class="error">'+response['error']+'</span>')
        }else{
            jQuery('#params_sender_form').closest('.control-group').find('.error').remove();
        }
        var options = '';
        jQuery.each(response.countries,function(id,name){
            var selected = '';
            if(id == jQuery('#params_opf_country').val()){
                selected = "selected";
            }
            options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
        });
        jQuery(select).append(options);
        if(jQuery('#params_opf_country').siblings('select').length > 0) {
            jQuery('#params_opf_country').siblings('select').replaceWith(select);
        }else{
            jQuery('#params_opf_country').before(select);
        }
        jQuery('#params_opf_country').val(jQuery('#params_opf_country').siblings('select').val());
        //-------------------------------------------------------------------------------------------------------

        //ОПФ----------------------------------------------------------------------------------------------------
        if(jQuery('#params_sender_form').val() == ""){
            jQuery('#params_sender_form').val('0x92ee03691f25a9fe4be9910cd87ca9ca');
        }
        var select = jQuery('<select>',
            {'data-prop_code':'sender_form',
                on:{
                    change:function(event){
                        jQuery(this).siblings('input').val(jQuery(this).val());
                    }
                }
            }
        );
        var options = "";
        var opfList;
        if(response.countries !== null){
            opfList = response.opf[jQuery('#params_opf_country').val()];
        }
        if(jQuery(opfList).length > 0){
            jQuery.each(opfList,function(id,name){
                var selected = '';
                if(id == jQuery('#params_sender_form').val()){
                    selected = "selected";
                }
                options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
            });
        }
        jQuery(select).append(options);
        if(jQuery('#params_sender_form').siblings('select').length > 0){
            jQuery('#params_sender_form').siblings('select').replaceWith(select);
        }else{
            jQuery('#params_sender_form').before(select);
        }
        jQuery('#params_sender_form').val(jQuery('#params_sender_form').siblings('select').val());
        hideLoading();
    });

}

function getRequestTerminalsDerival(){
    var kladr = jQuery('#params_kladr_code_delivery_from').val();
    var apikey = jQuery('#params_appkey').val();
    showLoading();
    return jQuery.ajax({
        url: "/plugins/vmshipment/dellin_shipping/dellin_ajax.php",
        data: {'ajax':'y','action':'get_terminals','mode':'request_terminals','kladr':kladr, 'appkey':apikey},
        method: "GET",
        dataType: "json"
    }).done(function(response){
        var select = jQuery('<select>',
            {'data-prop_code':'terminal_id',
                on:{
                    change:function(event){
                        jQuery(this).siblings('input').val(jQuery(this).val());
                    }
                }
            }
        );
        jQuery('#params_terminal_id').closest('.control-group').find('.error').remove();
        if(undefined != response['error']) {
            jQuery('#params_terminal_id').closest('.control-group').find('.control-label').append('<span class="error">' + response['error'] + '</span>')
        }
        var options = "";
        console.log(response.terminals);
        jQuery.each(response.terminals,function(id,value){
            var selected = '';
            if(id ==  jQuery('#params_terminal_id').val()){
                selected = "selected";
            }
            options +='<option '+selected+' value="'+id+'">'+value+'</option>';
        });
        jQuery(select).append(options);
        if(jQuery('#params_terminal_id').siblings('select').length > 0){
            jQuery('#params_terminal_id').siblings('select').replaceWith(select);
        }else{
            jQuery('#params_terminal_id').before(select);
        }
        jQuery('#params_terminal_id').val(jQuery('#params_terminal_id').siblings('select').val());
        hideLoading();
    });
}

function createFindKladrPopup(element,ajaxAction,limit){
    var msg = Joomla.JText._('VMSHIPMENT_DELLIN_SEARCH_MSG');
    var popup = jQuery('<div>',{
        class: 'kladrDiv popup-container',
        html:
            jQuery('<span>',{
                html:msg+'<br/>'
            }),
    });
    var kladrInput =  jQuery('<input>',{
        type:'text',
        name:'query',
        class:'kladr_autocomplete',
        on:{

            keyup:function(event){
                var bannedInputs = [16,17,18,20,33,34,35,36,44,45];
                if(jQuery.inArray(event.keyCode,bannedInputs)!== -1 ||(event.keyCode>=112 && event.keyCode<=123)){
                    event.preventDefault();
                }else{
                    findKladr(this,ajaxAction,limit);
                }
            }
        }
    });
    var kladrInputButton = jQuery('<input>',{
        type:'button',
        class:'setKladr btn btn-small button-apply btn-success',
        value:Joomla.JText._('VMSHIPMENT_DELLIN_BUTTON_SELECT'),
        on:{
            click: function(){
                setKladr(this);
            }
        }
    });
    var closePopupButton = jQuery('<input>',{
        type:'button',
        class:'close-popup btn btn-small button-cancel',
        value:Joomla.JText._('VMSHIPMENT_DELLIN_BUTTON_CLOSE'),
        on:{
            click: function(){
                removeThisPopup(this);
            }
        }
    });
    jQuery(popup).append(kladrInput,kladrInputButton,closePopupButton);
    jQuery(popup).insertAfter(element);
}
function findKladr(element,ajaxaction,limit){
    var data = {'ajax':'y','action':ajaxaction,'query':jQuery(element).val(),'count':limit};
    if(ajaxaction == 'search_street'){
        var relatedCityKladr = jQuery('.for_'+jQuery(element).closest('.control-input').find('.streetKladrInput').attr('id')).val();
        if(jQuery.trim(relatedCityKladr).length > 0){
            data.kladr = jQuery('.for_'+jQuery(element).closest('.control-input').find('.streetKladrInput').attr('id')).val();
        }else{
            data.kladr = jQuery('#params_kladr_code_delivery_from').val();
        }
        console.log(data.kladr);
        data.apikey = jQuery('#params_appkey').val();
        //data.cid = getUrlParameter('cid');
        data.login =  jQuery('#params_login').val();
        data.password =  jQuery('#params_password').val();
    }
    if(jQuery(element).val().length >= 2){
        jQuery.ajax({
            url: "/plugins/vmshipment/dellin_shipping/dellin_ajax.php",
            data: data,
            method: "GET",
            dataType: "json"
        }).done(function(response){
            jQuery(element).siblings('.autocomplete').remove();
            var autocompletepopup = jQuery('<div>',{
                    class:'autocomplete',
                }).append(jQuery('<div>',{
                    class:'rows'
            }));
            jQuery(autocompletepopup).insertAfter(jQuery(element));
            // console.log(jQuery(autocompletepopup));
            // console.log(jQuery('.autocomplete'));
            if(response.STATUS == "ERROR"){
                var text = response.BODY;
                jQuery(input).siblings('.autocomplete').find('.rows')
                    .append(
                        jQuery('<div>',{
                            class:'autocomplete-row',
                            on:{
                                click:function(){
                                    setAutoCompleteKladr(this)
                                }
                            },
                            text:response.BODY
                        })
                    );
            }else{
                jQuery.each(response,function(index,el){
                    var name = "";
                    if(ajaxaction == 'search_street'){
                        name = el.aString;
                    }else{
                        name = el.city;
                    }
                    jQuery(element).siblings('.autocomplete').find('.rows').append(
                        jQuery('<div>',{
                            class:'autocomplete-row',
                            on:{
                                click:function(){
                                    setAutoCompleteKladr(this);
                                }
                            },
                            'data-id': el.code,
                            text:name+' ['+el.code+']'
                        })
                    );
                });
            }


        });
    }
}
function setAutoCompleteKladr (element){
    console.log(jQuery(element).html())
    jQuery(element).closest('.kladrDiv').find('input[type=text]').first().val(jQuery(element).html()).attr('kladr',jQuery(element).data('id'));
    jQuery(element).closest('.autocomplete').remove();
}

function setKladr (element){
    jQuery(element).closest('.control-input').find('input[type=text]').first().val(jQuery(element).siblings('input[type=text]').attr('kladr'));
    jQuery(element).closest('.control-input').find('input[type=text]').first().trigger('change');
    jQuery(element).closest('.popup-container').remove();
}

function removeThisPopup(element){
    console.log('remove');
    jQuery(element).closest('.kladrDiv').remove();
}
