<?php

use Joomla\CMS\Application\ApplicationHelper;


define( '_JEXEC', 1 );
define( 'DS', DIRECTORY_SEPARATOR );
define('JPATH_SITE',$_SERVER['DOCUMENT_ROOT']);
if ( !defined( '_JDEFINES' ) ) {
	define( 'JPATH_BASE', JPATH_SITE );
	require_once JPATH_BASE . '/includes/defines.php';
}
if ( file_exists( JPATH_SITE . '/includes/defines.php' ) ) {
	include_once JPATH_SITE . '/includes/defines.php';
}
require_once JPATH_BASE . '/includes/framework.php';

if (!class_exists ('plgVmShipmentDellin_shipping')) {
	require(JPATH_PLUGINS . DS . 'vmshipment/dellin_shipping/dellin_shipping.php');
}
if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .'/components/com_virtuemart/helpers/config.php');
if (!class_exists( 'VmModel' )) require(JPATH_ADMINISTRATOR .'/components/com_virtuemart/helpers/vmmodel.php');
if (!class_exists( 'VmTable' )) require(JPATH_ADMINISTRATOR .'/components/com_virtuemart/helpers/vmtable.php');

$app = \JFactory::getApplication('site');
$lang = \JFactory::getLanguage();
$extension = 'plg_vmshipment_dellin_shipping';
$base_dir = JPATH_PLUGINS.'/vmshipment/dellin_shipping';
$language_tag = 'ru-RU';
$reload = true;
$lang->load($extension, $base_dir, $language_tag, $reload);
\JLoader::register('DellinApi', JPATH_PLUGINS . '/vmshipment/dellin_shipping/DellinClasses/DellinApi.php');
$vmConfig = VmConfig::loadConfig();



/**
 * Получаем данные пользователя для сборщика.
 * @param $order
 * @return array
 */

 function personInfoInOrder($order){
     $scheme = $order['details']['BT']->STsameAsBT;
     $orderPersonData = (($scheme == '1')&&($order['details']['has_ST'] == false))?
         $order['details']['BT'] : $order['details']['ST'];

     $fullAddress = $orderPersonData->address_1.' '.$orderPersonData->address_2;

     $country = VmModel::getModel('country');
     $country->setId($orderPersonData->virtuemart_country_id);
     $country_name = $country->getData()->country_name;


     $personInfo = array(
         'last_name' => $orderPersonData->last_name,
         'first_name' => $orderPersonData->first_name,
         'country' => $country_name,
         'state' => ShopFunctions::getStateByID($orderPersonData->virtuemart_state_id),
         'city' => $orderPersonData->city,
         'address' =>  $fullAddress,
         'postcode' => $orderPersonData->zip,
         'phone' => $orderPersonData->phone_1,
         'email' => $orderPersonData->email
     );


     return $personInfo;
}

/**
 * Получаем данные о товарах для сборщика
 * @param $order
 *
 * @return array
 */
 function getProductsParams($order){
    $items = $order['items'];
    return $items;
}

/**
 * Сборщик данных для заказа.
 * @param $order
 * @return stdClass
 */
function getOrderData($order){

    $cart = new \stdClass();
    $cart->person = personInfoInOrder($order);
    $cart->order_invoice = $order['details']['BT']->order_number;
    $cart->order_id = $order['details']['BT']->virtuemart_order_id;
    $cart->instance_id = $order['details']['BT']->virtuemart_shipmentmethod_id;
    $cart->shipping_country = $order['details']['BT']->virtuemart_country_id;
    $cart->cost_shpiment = $order['details']['ST']->order_shipment;
    $cart->order_total = $order['details']['BT']->order_total;
    $cart->payment_method_id = $order['details']['BT']->virtuemart_paymentmethod_id;
    $cart->payment_method_name = getPaymentThisMethod($cart->payment_method_id);
    $cart->person_type = 0;
    $cart->products = getProductsParams($order);


    return $cart;
}

function getPaymentThisMethod($payment_id){

    $paymentModel = VmModel::getModel('Paymentmethod');
    $payments = $paymentModel->getPayments(true, false);
    $paymentdata = [];

    foreach ($payments as $method){
        if($method->virtuemart_paymentmethod_id  === $payment_id){
            $paymentdata = [ 'name' => $method->payment_name];
        }
    }

    return $paymentdata['name'];
}


function convertParamsToArray($params){
    $rows = explode('|', $params);
    foreach($rows as $str) {
        $arElement = explode('=', $str);
        if( isset($arElement[1])) $arParams[$arElement[0]] = trim($arElement[1],'"');

    }
    return $arParams;
}

/**
 *
 * @param $methodId
 * @return array
 */

function getConfigShipmentMethod($methodId){
//
//	     var_dump($methodId);
//	     die();
    $db = Joomla\CMS\Factory::getDBO ();
    $prefix = $db->getPrefix();

    $table = $prefix.'virtuemart_shipmentmethods';

    $q = 'SELECT * FROM `'.$table.'` '
        .'WHERE `virtuemart_shipmentmethod_id` = ' . $methodId;
    $db->setQuery ($q);

    if (!($methodInfo = $db->loadObject())) {
        $msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $methodId);
        vmWarn ($msg);
        vmDebug($msg, $q . " " . $db->getErrorMsg ());
        return '';
    }


    $configData = convertParamsToArray($methodInfo->shipment_params);
    $configData['shipment_element'] = $methodInfo->shipment_element;

    return $configData;

}

if($app->input->getCmd('action') == 'get_counteragents')
{
	$config['login'] = trim($app->input->getString('login'));
	$config['password'] = trim($app->input->getString('password'));
	$config['appkey'] = trim($app->input->getString('appkey'));
	$config['reset_session'] = trim($app->input->getBool('reset_session'));
	$sessionID = DellinApi::GetDellinSessionId($config);

	$arCounterAgents = ['' => ['name'=>$lang->_('VMSHIPMENT_COUNTERAGENT_NOT_SELECTED')]];
	$counterAgents = Null;
	if(isset($sessionID) && $sessionID !== Null && !isset($sessionID->errors)) {
		$data = array('appkey' => $config['appkey'], 'sessionID' => $sessionID, "full_info" => true);
		$counterAgents  = DellinApi::getCounteragents($data);
		if(is_array($counterAgents)){
			$arCounterAgents = $arCounterAgents + $counterAgents;
		}
	}
	$result = array('counteragents'=>$arCounterAgents,'sessionID'=>$sessionID);
	if($counterAgents == null){
		$result['error'] = $lang->_('VMSHIPMENT_DELLIN_SHIPPING_API_NOT_AVAILABLE');
	}
	echo json_encode($result);
}

if($app->input->getCmd('action') == 'get_opf'){
	$appkey = trim($app->input->getString('appkey'));
	$arOpf = DellinApi::GetOpf($appkey);
	if(empty($arOpf['opf']) && empty($arOpf['country'])){
		$arOpf['error'] = $lang->_('VMSHIPMENT_DELLIN_SHIPPING_API_NOT_AVAILABLE');
	}
	echo json_encode($arOpf);
}

if($app->input->getCmd('action') == 'get_terminals'){
	if($app->input->getCmd('mode') == "request_terminals" ){//все терминалы доступные по направлению
        $arTerminalIdValues = false;
		$arTerminals[''] = $lang->_('VMSHIPMENT_TERMINAL_NOT_SELECTED');
		$apiKey = $app->input->getString('appkey');
		if($apiKey){
			if("" !== $app->input->getString('kladr')){
				$data = array(
					"appkey" =>$apiKey,
					"code" => $app->input->getString('kladr'),
					"direction" => "derival"
				);
				$arTerminalIdValues = DellinApi::getRequestTerminals($data);
				if(is_array($arTerminalIdValues)){
					$arTerminals = $arTerminals + $arTerminalIdValues;
				}else{
                   $result['error'] = $lang->_('VMSHIPMENT_DELLIN_SHIPPING_API_NOT_AVAILABLE');
                }

			}else{
				//error no kladr
                $result['error'] = $lang->_('VMSHIPMENT_EMPTY_DERIVAL_POINT');
			}
		}else{
            $result['error'] = $lang->_('VMSHIPMENT_NO_APP_KEY');
        }
		$result['terminals'] = $arTerminals;

		echo json_encode($result);
	}
}

if($app->input->getCmd('action') == 'search_city'){

		$cities = [];
		$query = str_replace($lang->_('YO'),$lang->_('YE'),$app->input->getString('query'));
		// Формируем строку запроса и отправляем.
		$cities = DellinApi::SearchCity($query);
		$result = array_slice($cities,0,$app->input->getCmd('count'));
		echo json_encode($result);
}
if($app->input->getCmd('action') == 'search_street') {
//	$m = VmModel::getModel('shipmentmethod');
//	$deliveryId = $app->input->getInt('cid');
//	$deliveryConfig = $m->getShipment($deliveryId)->shipment_params;
//	$params = [];
//	echo "<pre>";
//	VmTable::bindParameterable($m,'shipment_params',$params);
//	var_dump($params);
//	echo "</pre>";
//	die();
    $kladr = $app->input->getCmd('kladr');
    $apiKey = $app->input->getCmd('apikey');
    $street = $app->input->getString('query');
    $count = $app->input->getInt('count');
    $login = $app->input->getString('login');
    $password = $app->input->getString('password');
    $streets = [];
    $arParams = array(
        "appkey" => $apiKey,
        "code" => $kladr,
        "street" => $street,
        "limit" => $count ? $count : 2
    );
    if (isset($login) && isset($password)) {
        $sessionID = DellinAPI::GetDellinSessionId(['appkey' => $apiKey, 'login' => $login, 'password' => $password]);
        if (isset($sessionID)) {
            $arParams["sessionID"] = $sessionID;
        }

    }
    $streets = DellinApi::GetStreetKladr($arParams);
    $result = $streets['streets'];
    echo json_encode($result);

}

//var_dump($app->input);
//die();
if($app->input->getCmd('action') == 'send_request') {

    $token = $app->input->getCmd('security');
    $id = $app->input->getCmd('id');
    $instance_id = $app->input->getCmd('instanceid');
    $userId = $app->input->getCmd('userid');

    //Обрабатываем вопрос безопасности
    //Вам смешно, а джомлу постоянно ломают, так что хоть шторку повесить.
    $secretDirect = 'dellin-request'.date('Y-m-d');
    $hash = ApplicationHelper::getHash($userId. $secretDirect);


    if ($token === $hash)
    {

        $config = getConfigShipmentMethod($instance_id);
        $dataOrder = getOrderData(VirtueMartModelOrders::getOrder($id));

        $replacedString = preg_replace("/\\\\u([0-9abcdef]{4})/", "&#x$1;", $config);
        $config = mb_convert_encoding($replacedString, 'UTF-8', 'HTML-ENTITIES');

        $response = DellinApi::CreateOrder($dataOrder, $config);

//
//        echo '<pre>';
//        var_dump($response);
//        echo '</pre>';
//        die();

        $result = $response;

        echo json_encode($result);

    } else {


        echo json_encode(false);
    }


}


