<?php

defined ('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Application;
use Joomla\CMS\Application\ApplicationHelper;
use Joomla\CMS\Filter\InputFilter as Input;


/**
 * Shipment plugin for dellin_shipping shipments, like regular postal services
 *
 * @version $Id: dellin_shipping.php 10313 2020-05-04 13:21:09Z Milbo $
 * @package VirtueMart
 * @subpackage Plugins - shipment
 * @copyright Copyright (C) 2004-2012 VirtueMart Team - All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.org
 * @author Valerie Isaksen
 *
 */


if (!class_exists( 'vmDefines' )) {
	require(JPATH_ADMINISTRATOR .'/components/com_virtuemart/helpers/vmdefines.php');
	vmDefines::defines(1);
}
if (!class_exists ('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}
if (!class_exists( 'VmConfig' )) {
	require(JPATH_ADMINISTRATOR .'/components/com_virtuemart/helpers/config.php');
	//VmConfig::loadConfig();
}
if (!class_exists ('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}
\JLoader::register('DellinApi', JPATH_PLUGINS . '/vmshipment/dellin_shipping/DellinClasses/DellinApi.php');
\JLoader::register('ApiCore', JPATH_PLUGINS . '/vmshipment/dellin_shipping/DellinClasses/ApiCore.php');
\JLoader::register('DellinTrait', JPATH_PLUGINS . '/vmshipment/dellin_shipping/DellinClasses/DellinTrait.php');

jimport('joomla.plugin.plugin');


class plgVmShipmentDellin_shipping extends vmPSPlugin {


    use DellinTrait;
	/**
	 * @param object $subject
	 * @param array  $arConfig
	 */

	function __construct (& $subject, $config) {
		parent::__construct ($subject, $config);
		$this->_loggable = TRUE;
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$varsToPush = $this->getVarsToPush ();
		$this->addVarsToPushCore($varsToPush,0);


		$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
		$this->setConvertable(array('min_amount','max_amount','shipment_cost','package_fee'));
		vmdebug('Muh constructed plgVmShipmentWeight_countries',$varsToPush);
	}





    public function onBeforeCompileHead(){
        $app = new Application\CMSApplication();
        if($app->input->getCmd('view') == 'shipmentmethod' && $app->input->getCmd('task') == 'edit' && $this->getVmPluginMethod($app->input->getCmd('cid')[0])->shipment_element == 'dellin_shipping')
        {
	        JHtml::_('jquery.framework');
	        JHtml::script(JURI::root() . '/plugins/vmshipment/dellin_shipping/assets/js/dellinDeliverySettings.js');
	        JHtml::stylesheet(JURI::root() . '/plugins/vmshipment/dellin_shipping/assets/css/dellinDeliverySettings.css');
	        self::loadJSLanguageKeys('/plugins/vmshipment/dellin_shipping/assets/js/dellinDeliverySettings.js');
        }
    }

	/**
	 * Parses a javascript file looking for JText keys and then loads them ready for use.
	 *
	 * @param   string  $jsFile  Path to the javascript file.
	 *
	 * @return bool
	 */
	public  static function loadJSLanguageKeys($jsFile)
	{
		if (isset($jsFile))
		{
			$jsFile = JPATH_SITE . $jsFile;
		}
		else
		{
			return false;
		}

		if ($jsContents = file_get_contents($jsFile))
		{
			$languageKeys = array();
			preg_match_all('/Joomla\.JText\._\(\'(.*?)\'\)\)?/', $jsContents, $languageKeys);
			$languageKeys = $languageKeys[1];
			foreach ($languageKeys as $lkey)
			{
				JText::script($lkey);
			}
		}
	}

	/**
	 * Create the table for this plugin if it does not yet exist.
	 *
	 * @author Valérie Isaksen
	 */

	public function getVmPluginCreateTableSQL () {

		return $this->createTableSQL ('Shipment Weight Countries Table');
	}

	/**
	 * @return array
	 */
	function getTableSQLFields () {

		$SQLfields = array(
			'id'                           => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id'          => 'int(11) UNSIGNED',
			'order_number'                 => 'char(32)',
			'virtuemart_shipmentmethod_id' => 'mediumint(1) UNSIGNED',
			'shipment_name'                => 'varchar(5000)',
            'shipping_days_terminal'       => 'int(11)',
            'shipping_days_address'        => 'int(11)',
            'tracking_id'                  => 'varchar(255)',
            'order_terminal_id'            => 'int(11)'
		);
	
		return $SQLfields;
	}

	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the shipment-specific data.
	 *
	 * @param integer $virtuemart_order_id The order ID
	 * @param integer $virtuemart_shipmentmethod_id The selected shipment method id
	 * @param string  $shipment_name Shipment Name
	 * @return mixed Null for shipments that aren't active, text (HTML) otherwise
	 * @author Valérie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmOnShowOrderFEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id, &$shipment_name) {

        $view = '';
     //   if (!($this->selectedThisByMethodId ($virtuemart_shipmentmethod_id))) {

            $config = $this->getConfigShipmentMethod($virtuemart_shipmentmethod_id);
            $isTerminal = ($config['is_goods_unloading'] !== '1');
            $orderData = $this->getOrderData(VirtueMartModelOrders::getOrder($virtuemart_order_id));

            $terminalInfo = $this->getTerminalInfoOfOrder($orderData, $config);
            $terminal_id = self::getArrivalTerminal($orderData);
            $terminal_data = DellinApi::GetTerminals($config['appkey'], true, (int)$terminal_id);

//            echo '<pre>';
//            var_dump($orderData);
//            echo '</pre>';
//            die();

            $fullAddress = ($isTerminal)?$terminalInfo->fullAddress : $orderData->person['full_address'];
            $tracking_id = $this->getTrackingId($virtuemart_order_id);
            $response_status = self::GetOrderStatus($tracking_id, $config['appkey']);
            $dateCreateRequest = $response_status->documents[0]->create_date;
            $dateGoToReceiver = $response_status->order_dates->arrival_to_osp_receiver;
            $addressHeader = ($isTerminal)?'Адрес терминала':'Адрес доставки';

            if(isset($tracking_id) && ($tracking_id !== "0")){
                $view.= '<div >';
                $view.= '<table class="jshop cart">';
                $view.= '<tbody><tr>';
                $view.= '<th>Трек номер</th>'.
                    '<th >Статус доставки</th>'.
                    '<th >Дата создания заявки</th>'.
                    '<th >Ориентировочный срок прибытия</th>'.
                    '<th >'.$addressHeader.'</th>'.
                    '<tr>';
                $view.= '<td >'.$tracking_id.'</td>'.
                    '<td >'.$response_status->state_name.'</td>'.
                    '<td >'.$dateCreateRequest.'</td>'.
                    '<td >'.$dateGoToReceiver.'</td>'.
                    '<td>'. $fullAddress.'</td>'.
                    '</tr></tbody></table></div>';
          //  } else {
          //      $view.= "Извините, но заявка пока не создана.";
          //  }
            echo $view;
        }


		$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_shipmentmethod_id, $shipment_name);


	}


	function getTrackingId($order_id){

        $db = JFactory::getDBO ();
        $q = 'SELECT `tracking_id` FROM `' . $this->_tablename . '` '
            . 'WHERE `virtuemart_order_id` = ' . $order_id;
        $db->setQuery ($q);
        if (!($shipinfo = $db->loadObject())) {
            $msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $order_id);
            vmWarn ($msg);
            vmDebug($msg, $q . " " . $db->getErrorMsg ());
            return '';
        }
        return $shipinfo->tracking_id;
    }


    function getTerminalInfoOfOrder($dataOrder, $arConfig){

        $terminal_id = self::getArrivalTerminal($dataOrder);


        $terminal_data = ApiCore::GetTerminals($arConfig['appkey'], true, (int)$terminal_id);



        return $terminal_data['terminal'];
    }

	/**
	 * This event is fired after the order has been stored; it gets the shipment method-
	 * specific data.
	 *
	 * @param int    $order_id The order_id being processed
	 * @param object $cart  the cart
	 * @param array  $order The actual order saved in the DB
	 * @return mixed Null when this method was not selected, otherwise true
	 * @author Valerie Isaksen
	 */
	function plgVmConfirmedOrder (VirtueMartCart $cart, $order) {

		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_shipmentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->shipment_element)) {
			return FALSE;
		}

        $typeUnLoad = $this->getConfigShipmentMethod($order['details']['BT']->virtuemart_shipmentmethod_id)['is_goods_unloading'];


		$values['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
		$values['order_number'] = $order['details']['BT']->order_number;
		$values['virtuemart_shipmentmethod_id'] = $order['details']['BT']->virtuemart_shipmentmethod_id;
		$values['shipment_name'] = $this->renderPluginName ($method);
		$values['order_weight'] = $this->getOrderWeight ($cart, $method->weight_unit);
		$values['shipment_weight_unit'] = $method->weight_unit;
		$values['order_terminal_id'] = $_POST['order_terminal_id'];
		$values['shipping_days_terminal'] = $_SESSION['shipping_days_terminal'];
		$values['shipping_days_address'] = $_SESSION['shipping_days_address'];

		$costs = $this->getCosts($cart,$method,$cart->cartPrices);
//		echo "<pre>";
//		var_dump($values);
//		echo '</pre>';
//		die();

		if(!empty($costs)){
			$values['shipment_cost'] = $method->shipment_cost;
			$values['shipment_package_fee'] = $method->package_fee;
		}
		if(empty($values['shipment_cost'])) $values['shipment_cost'] = 0.0;
		if(empty($values['shipment_package_fee'])) $values['shipment_package_fee'] = 0.0;

		$values['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData ($values);

		return TRUE;
	}

	/**
	 * This method is fired when showing the order details in the backend.
	 * It displays the shipment-specific data.
	 * NOTE, this plugin should NOT be used to display form fields, since it's called outside
	 * a form! Use plgVmOnUpdateOrderBE() instead!
	 *
	 * @param integer $virtuemart_order_id The order ID
	 * @param integer $virtuemart_shipmentmethod_id The order shipment method ID
	 * @return mixed Null for shipments that aren't active, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderBEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id) {

		if (!($this->selectedThisByMethodId ($virtuemart_shipmentmethod_id))) {
			return NULL;
		}
		$html = $this->getOrderShipmentHtml ($virtuemart_order_id);


		return $html;
	}



	/**
     *
	 * @param $virtuemart_order_id
	 * @return string
	 */
	function getOrderShipmentHtml ($virtuemart_order_id) {

		$db = JFactory::getDBO ();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery ($q);
		if (!($shipinfo = $db->loadObject())) {
			$msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $virtuemart_order_id);
			vmWarn ($msg);
			vmDebug($msg, $q . " " . $db->getErrorMsg ());
			return '';
		}



		$currency = CurrencyDisplay::getInstance ();
		$tax = ShopFunctions::getTaxByID ($shipinfo->tax_id);
		$taxDisplay = is_array ($tax) ? $tax['calc_value'] . ' ' . $tax['calc_value_mathop'] : $shipinfo->tax_id;
		$taxDisplay = ($taxDisplay == -1) ? vmText::_ ('COM_VIRTUEMART_PRODUCT_TAX_NONE') : $taxDisplay;

        $order = VirtueMartModelOrders::getOrder($virtuemart_order_id);
        $methodShipmentId = $order['details']['ST']->virtuemart_shipmentmethod_id;
        $arConfig = $this->getConfigShipmentMethod($methodShipmentId);



        $orderData = $this->getOrderData($order);
        $tracking_id = ($shipinfo->tracking_id == '0')?"Заявка не создана":$shipinfo->tracking_id;
        $status = ($shipinfo->tracking_id == '0')?'Заявка не создана' :
                                                  self::GetOrderStatus($tracking_id, $arConfig['appkey'])->state_name;
        $button = ($shipinfo->tracking_id == '0')?'<a href="#modal-dellin" data-toggle="modal" class="btn">Подробнее</a>' :
                                                   '';


		$html = '<table class="adminlist table">'."\n";
		$html .= $this->getHtmlHeaderBE ();

        $html .= $this->getHtmlRowBE ('VMSHIPMENT_DELLIN_SHIPPING_REQUEST_METHOD', $shipinfo->shipment_name);
        $html .= $this->getHtmlRowBE ('VMSHIPMENT_DELLIN_SHIPPING_REQUEST_TRACK_ID', $tracking_id);
        $html .= $this->getHtmlRowBE ('VMSHIPMENT_DELLIN_SHIPPING_REQUEST_STATUS', $status);
        $html .= $this->getHtmlRowBE ('VMSHIPMENT_DELLIN_SHIPPING_REQUEST_COST', $currency->priceDisplay ($orderData->cost_shpiment));
        $html .= $this->getHtmlRowBE ('', $button );

		$html .= '</table>' . "\n";

        $body = $this->modalBody($arConfig, $orderData);

		$this->initModal($body);


		return $html;
	}


    public static function GetOrderStatus($trackID, $appkey){


        $params = array('appkey' => $appkey, 'docid' => $trackID);

        if (isset($params['docid'])) {
            $result = ApiCore::GetStatus($params);
            return $result;
        } else {
            return false;
        }

        if ($result && !isset($result->errors)) {
            return get_object_vars($result);
        } else {
            return false;
        }

    }



	public function initModal($body){

        $params = array();
        $params['title']  = "Сведения о заявке на доставку";
        $params['height'] = 400;
        $params['width']  = 560;
        $html = JHtml::script(JURI::root() . '/plugins/vmshipment/dellin_shipping/assets/js/dellinDeliveryRequest.js');
	    $html.= JHtml::stylesheet(JURI::root() . '/plugins/vmshipment/dellin_shipping/assets/css/dellinDeliveryRequest.css');
        echo $html.= JHtml::_('bootstrap.renderModal', 'modal-dellin', $params, $body);

		return $html;
	}

    function getPaymentThisMethod($payment_id){

        $paymentModel = VmModel::getModel('Paymentmethod');
        $payments = $paymentModel->getPayments(true, false);
        $paymentdata = [];

        foreach ($payments as $method){
            if($method->virtuemart_paymentmethod_id  === $payment_id){
                $paymentdata = [ 'name' => $method->payment_name];
            }
        }

        return $paymentdata['name'];
    }


    protected static function getShippingDays($order_id){
        $db = JFactory::getDBO ();
        $prefix = $db->getPrefix();
        $q = 'SELECT * FROM `'.$prefix.'virtuemart_shipment_plg_dellin_shipping` '
            . 'WHERE `virtuemart_order_id` = ' . $order_id;
        $db->setQuery ($q);
        if (!($dellininfo = $db->loadObject())) {
            $msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $order_id);
            vmWarn ($msg);
            vmDebug($msg, $q . " " . $db->getErrorMsg ());
            return '';
        }

        return  ['for_terminal' => $dellininfo->shipping_days_terminal,
                 'for_address' => $dellininfo->shipping_days_address ];

    }

    protected static function getArrivalTerminal($dataOrder)
    {

        $db = JFactory::getDBO ();
        $prefix = $db->getPrefix();
        $q = 'SELECT * FROM `'.$prefix.'virtuemart_shipment_plg_dellin_shipping` '
            . 'WHERE `virtuemart_order_id` = ' . $dataOrder->order_id;
        $db->setQuery ($q);

        if (!($dellininfo = $db->loadObject())) {
            $msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $dataOrder->order_id);
            vmWarn ($msg);
            vmDebug($msg, $q . " " . $db->getErrorMsg ());
            return '';
        }

        return $dellininfo->order_terminal_id;
    }



    protected static function getLoadingLoadingTypes($value){
        switch($value){
            case 'NULL':
                return 'Задняя погрузка';
                break;
            case '0xb83b7589658a3851440a853325d1bf69':
                return 'Боковая погрузка';
                break;
            case '0xabb9c63c596b08f94c3664c930e77778':
                return 'Верхняя погрузка';
                break;
        }
    }


    protected static function getLoadingUnloadingTypes($value){
        switch($value){
            case 'NULL':
                return 'Задняя разгрузка';
                break;
            case '0xb83b7589658a3851440a853325d1bf69':
                return 'Боковая разгрузка';
                break;
            case '0xabb9c63c596b08f94c3664c930e77778':
                return 'Верхняя разгрузка';
                break;
        }
    }

    protected static function getAdditionalTransportRequirements($value){
        switch($value){
            case 'NULL':
                return 'Не требуется';
                break;
            case '0x9951e0ff97188f6b4b1b153dfde3cfec':
                return 'Открытая';
                break;
            case '0x818e8ff1eda1abc349318a478659af08':
                return 'Требуется растентовка';
                break;
        }
    }

    protected static function getAdditionalTransportEquipments($value){
        switch($value){
            case 'NULL':
                return 'Не требуется';
                break;
            case '0x92fce2284f000b0241dad7c2e88b1655':
                return 'Гидроборт';
                break;
            case '0x88f93a2c37f106d94ff9f7ada8efe886':
                return 'Манипулятор';
                break;
        }
    }



	protected function modalBody($arConfig, $dataOrder){

        $dateNow = date('Y-m-d');

        $dayDelay = (empty($arConfig['delivery_delay'])) ? 0 : (int)$arConfig['delivery_delay'];

        $dateDelay = date('Y-m-d', strtotime($dateNow.'+ '.$dayDelay.' days'));
        $data_shipping_days = $this->getShippingDays($dataOrder->order_id);
        $shipping_days = ($arConfig['is_goods_unloading'] == '')?$data_shipping_days['for_terminal'] :
                                                                 $data_shipping_days['for_address'] ;

        $fullAddress = $dataOrder->person['state'].', '.$dataOrder->person['city'].', '.$dataOrder->person['address'];
        $terminal_id = self::getArrivalTerminal($dataOrder);
        $terminal_data = DellinApi::GetTerminals($arConfig['appkey'], true, $terminal_id);
        $isTerminal = ($arConfig['is_goods_unloading'] !== '1');
        $addressHeader = ($isTerminal)?'Адрес терминала':'Адрес доставки';

        $addressTerminal = $terminal_data['terminal']->fullAddress;

        $address = ($arConfig['is_goods_unloading'] == '')? $addressTerminal : $fullAddress;

        $dateSend = date('Y-m-d', strtotime($dateDelay.'+ '.$shipping_days.' days'));

        $arRowsStatus = array(  //array('Статус:', $status),
                                //array('Трек номер:', $trackId),
                                array('Дата отправки:', $dateDelay),
                                array('Дата доставки:', $dateSend)
        );

        $arRowsContact = array(
            array('Тип доставки:', ($arConfig['is_goods_unloading'] == '')? 'до терминала':'до адреса'),
            array('Город:', $dataOrder->person['city']),
            array('Имя:', $dataOrder->person['first_name']),
            array('Фамилия:', $dataOrder->person['last_name'])
        );

        $arRowsLoad = array(
            array('Специальные требования к транспорту:', self::getAdditionalTransportEquipments($arConfig['loading_additional_equipment']) ),
            array('Дополнительная комплектация:', self::getAdditionalTransportRequirements($arConfig['loading_transport_requirements'])),
            array('Тип разгрузки машины:', self::getLoadingLoadingTypes($arConfig['loading_type']))
        );

        $arRowsUnLoad = array(
            array('Специальные требования к транспорту:', self::getAdditionalTransportEquipments($arConfig['unloading_additional_equipment'])),
            array('Дополнительная комплектация:', self::getAdditionalTransportRequirements($arConfig['unloading_transport_requirements'])),
            array('Тип разгрузки машины:', self::getLoadingUnloadingTypes($arConfig['unloading_type']))
        );

        $arRowsOther = array(
//          array('Тип платильщика:', ($dataOrder['shipping']['company'] == 'on')?__('Organization','dellin-shipping-for-woocommerce'): __('individual','dellin-shipping-for-woocommerce') ),
            array($addressHeader, $address),
            array('Стоимость доставки:', $dataOrder->cost_shpiment),
        );

       $secretDirect = 'dellin-request'.$dateNow;
       $user = JFactory::getUser();
       $userid = $user->id;
       $token = ApplicationHelper::getHash($userid. $secretDirect);

       $orderId = $dataOrder->order_id;

       $instanceId = $dataOrder->instance_id;
       $button =  '<a id="submit" style="margin: 5px 10px 25px 20px;" data-token = "'.
                   $token.'" data-userid ="'.$userid.'" data-orderId = "'.
                   $orderId.'"data-instanceId = "'.$instanceId.'" class="btn">Создать заявку</a>';




	   $html = '<div class="dellin__modal_header" style="width:100%">'.
                    '<h3 class="dellin__modal_header-title">'.
                    'Подробные сведения по доставке "Деловые линии". Заказ №:'.$orderId.
                    '</h3>'.
                    '<div class="dellin__modal_rows">'.
                        $this->modalBodyIterArray($arRowsStatus).
                        '<hr/>'.
                    '</div>'.
                    '<div class="dellin__modal_rows">'.
                        $this->modalBodyIterArray($arRowsContact).
                        '<hr/>'.
                    '</div>'.
                    '<div class="dellin__modal_rows-item">'.
                        '<strong>'.
                        'Дополнительные параметры выгрузки:'.
                        '</strong>'.
                        '<div class="dellin__modal_rows-itemlist">'.
                            $this->modalBodyIterArray($arRowsUnLoad).
                            '<hr/>'.
                        '</div>'.
                    '</div>'.
                    '<div class="dellin__modal_rows-item">'.
                        '<strong>'.
                        'Дополнительные параметры погрузки:'.
                        '</strong>'.
                        '<div class="dellin__modal_rows-itemlist">'.
                        $this->modalBodyIterArray($arRowsLoad).
                        '<hr/>'.
                        '</div>'.
                    '</div>'.
                      '<div class="dellin__modal_rows">'.
                      $this->modalBodyIterArray($arRowsOther).
                      '<hr/>'.
                      '</div>'.
                       '<div class="dellin__modal_rows">'.

                      $this->getTerminalData($dataOrder, $arConfig).
                       '<hr/>'.
                       '</div>'.
               $button.
               '</div>';



	    return $html;

    }

    protected static function modalBodyIterArray($dataInArray){

        $result = '';
        foreach ($dataInArray as $value){
            $result .= self::getRowInModal($value[0], $value[1]);
        }

        return $result;
    }

    protected static function getRowInModal($rowTitle, $rowData){
        $html = '<div class="dellin__modal_rows-item">'.
            $rowTitle.'<strong>'.$rowData.'</strong>'.'</div>';
        return $html;
    }


    protected static function getTerminalData($dataOrder, $arConfig){
	    if($arConfig['is_goods_unloading'] == ''){
            $terminal_id = self::getArrivalTerminal($dataOrder);
            $terminal_data = DellinApi::GetTerminals($arConfig['appkey'], true, (int)$terminal_id);
            $arTerminalInfo = [
                ['Номер терминала доставки:', $terminal_data['terminal']->id],
                ['Имя терминала доставки:', $terminal_data['terminal']->name],
                ['Адрес терминала доставки:', $terminal_data['terminal']->fullAddress]
            ];
           self::modalBodyIterArray($arTerminalInfo);
        }
    }

    /**
     *
     * @param $methodId - идентификатор метода доставки
     * @return array
     */

	 function getConfigShipmentMethod($methodId){


         $db = JFactory::getDBO ();
         $prefix = $db->getPrefix();

         $table = $prefix.'virtuemart_shipmentmethods';

         $q = 'SELECT * FROM `'.$table.'` '
             .'WHERE `virtuemart_shipmentmethod_id` = ' . $methodId;
         $db->setQuery ($q);

         if (!($methodInfo = $db->loadObject())) {
             $msg=vmText::sprintf('VMSHIPMENT_WEIGHT_COUNTRIES_NO_ENTRY_FOUND', $methodId);
             vmWarn ($msg);
             vmDebug($msg, $q . " " . $db->getErrorMsg ());
             return '';
         }

         $configData = $this->convertParamsToArray($methodInfo->shipment_params);
         $configData['shipment_element'] = $methodInfo->shipment_element;

         return $configData;

    }

    /**
     * Получаем данные пользователя для сборщика.
     * @param $order
     * @return array
     */

	public function personInfoInOrder($order){
	    $scheme = $order['details']['BT']->STsameAsBT;
	    $orderPersonData = (($scheme == '1')&&($order['details']['has_ST'] == false))?
                            $order['details']['BT'] : $order['details']['ST'];

	    $fullAddress = $orderPersonData->address_1.' '.$orderPersonData->address_2;

        $country = VmModel::getModel('country');
        $country->setId($orderPersonData->virtuemart_country_id);
        $country_name = $country->getData()->country_name;
        $deliveryAddress = $country_name.', '.ShopFunctions::getStateByID($orderPersonData->virtuemart_state_id).
                           ', '.$orderPersonData->city.', '.$fullAddress.'';


        $personInfo = array(
            'last_name' => $orderPersonData->last_name,
            'first_name' => $orderPersonData->first_name,
            'country' => $country_name,
            'state' => ShopFunctions::getStateByID($orderPersonData->virtuemart_state_id),
            'city' => $orderPersonData->city,
            'address' =>  $fullAddress,
            'postcode' => $orderPersonData->zip,
            'phone' => $orderPersonData->phone_1,
            'email' => $orderPersonData->email,
            'full_address' => $deliveryAddress
         );


        return $personInfo;
    }

    /**
     * Получаем данные о товарах для сборщика
     * @param $order
     *
     * @return array
     */
    protected function getProductsParams($order){
        $items = $order['items'];
	    return $items;
    }



    /**
     * Сборщик данных для заказа.
     * @param $order
     * @return stdClass
     */
    public function getOrderData($order){


        $cart = new \stdClass();
        $cart->person = $this->personInfoInOrder($order);
        $cart->order_invoice = $order['details']['BT']->order_number;
        $cart->order_id = $order['details']['BT']->virtuemart_order_id;
        $cart->instance_id = $order['details']['BT']->virtuemart_shipmentmethod_id;
        $cart->shipping_country = $order['details']['BT']->virtuemart_country_id;
        $cart->cost_shpiment = round(($order['details']['ST']->order_shipment*1.2),0);
        $cart->order_total = $order['details']['BT']->order_total;
        $cart->payment_method_id = $order['details']['BT']->virtuemart_paymentmethod_id;
        $cart->payment_method_name = $this->getPaymentThisMethod($cart->payment_method_id);
        $cart->person_type = 0;
        $cart->products = $this->getProductsParams($order);



        return $cart;
    }

	/**
	 * @param VirtueMartCart $cart
	 * @param                $method
	 * @param                $cart_prices
	 * @return int
	 */
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {

	    $deliveryConfig = $this->convertParamsToArray($method->shipment_params);

        $replacedString = preg_replace("/\\\\u([0-9abcdef]{4})/", "&#x$1;", $deliveryConfig);
        $deliveryConfig = mb_convert_encoding($replacedString, 'UTF-8', 'HTML-ENTITIES');

//        echo '<pre>';
//        var_dump($cart_prices);
//        echo '</pre>';
//        die();

        return $this->Calculate($cart,$deliveryConfig)['body'][0]/120*100;
	}

	function convertParamsToArray($params){
		$rows = explode('|', $params);
		foreach($rows as $str) {
			$arElement = explode('=', $str);
			if( isset($arElement[1])) $arParams[$arElement[0]] = trim($arElement[1],'"');

		}
		return $arParams;
	}

	/**
	 * @param \VirtueMartCart $cart
	 * @param int             $method
	 * @param array           $cart_prices
	 * @return bool
	 */
	protected function checkConditions ($cart, $method, $cart_prices) {

		$deliveryConfig = $this->convertParamsToArray($method->shipment_params);
        $replacedString = preg_replace("/\\\\u([0-9abcdef]{4})/", "&#x$1;", $deliveryConfig);
        $deliveryConfig = mb_convert_encoding($replacedString, 'UTF-8', 'HTML-ENTITIES');

     //  $this->setPrice();
		$calcResult = $this->Calculate($cart, $deliveryConfig, true);


		if ($calcResult['status'] == 'error') {
			return false;
		}else{
			return true;
		}
	}

	/**
	 * @param $method
	 */
	function convert (&$method) {

		//$method->weight_start = (float) $method->weight_start;
		//$method->weight_stop = (float) $method->weight_stop;
		$method->min_amount = (float)str_replace(',','.',$method->min_amount);
		$method->max_amount = (float)str_replace(',','.',$method->max_amount);
		$method->zip_start = (int)$method->zip_start;
		$method->zip_stop = (int)$method->zip_stop;
		$method->nbproducts_start = (int)$method->nbproducts_start;
		$method->nbproducts_stop = (int)$method->nbproducts_stop;
		$method->free_shipment = (float)str_replace(',','.',$method->free_shipment);
	}

	/**
	 * @param $cart
	 * @param $method
	 * @return bool
	 */
	private function _nbproductsCond ($cart, $method) {

		if (empty($method->nbproducts_start) and empty($method->nbproducts_stop)) {
			//vmdebug('_nbproductsCond',$method);
			return true;
		}

		$nbproducts = 0;
		foreach ($cart->products as $product) {
			$nbproducts += $product->quantity;
		}

		if ($nbproducts) {

			$nbproducts_cond = $this->testRange($nbproducts,$method,'nbproducts_start','nbproducts_stop','products quantity');

		} else {
			$nbproducts_cond = false;
		}

		return $nbproducts_cond;
	}


	private function testRange($value, $method, $floor, $ceiling,$name){

		$cond = true;
		if(!empty($method->$floor) and !empty($method->$ceiling)){
			$cond = (($value >= $method->$floor AND $value <= $method->$ceiling));
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is NOT within Range of the condition from '.$method->$floor.' to '.$method->$ceiling;
			} else {
				$result = 'TRUE';
				$reason = 'is within Range of the condition from '.$method->$floor.' to '.$method->$ceiling;
			}
		} else if(!empty($method->$floor)){
			$cond = ($value >= $method->$floor);
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is not at least '.$method->$floor;
			} else {
				$result = 'TRUE';
				$reason = 'is over min limit '.$method->$floor;
			}
		} else if(!empty($method->$ceiling)){
			$cond = ($value <= $method->$ceiling);
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is over '.$method->$ceiling;
			} else {
				$result = 'TRUE';
				$reason = 'is lower than the set '.$method->$ceiling;
			}
		} else {
			$result = 'TRUE';
			$reason = 'no boundary conditions set';
		}

		if(!$result) vmdebug('shipmentmethod '.$method->shipment_name.' = '.$result.' for variable '.$name.' = '.$value.' Reason: '.$reason);
		return $cond;
	}


	function plgVmOnProductDisplayShipment($product, &$productDisplayShipments){

//		if ($this->getPluginMethods($product->virtuemart_vendor_id) === 0) {
//
//			return FALSE;
//		}
//
//		$html = array();
//
//		$currency = CurrencyDisplay::getInstance();
//		foreach ($this->methods as $this->_currentMethod) {
//
//			if($this->_currentMethod->show_on_pdetails){
//
//				if(!isset($cart)){
//					$cart = VirtueMartCart::getCart();
//					$cart->products['virtual'] = $product;
//					$cart->_productAdded = true;
//					$cart->prepareCartData();
//				}
//				if($this->checkConditions($cart,$this->_currentMethod,$cart->cartPrices)){
//
//					$product->prices['shipmentPrice'] = $this->getCosts($cart,$this->_currentMethod,$cart->cartPrices);
//
//					if(isset($product->prices['VatTax']) and count($product->prices['VatTax'])>0){
//						reset($product->prices['VatTax']);
//						$rule = current($product->prices['VatTax']);
//						if(isset($rule[1])){
//							$product->prices['shipmentTax'] = $product->prices['shipmentPrice'] * $rule[1]/100.0;
//							$product->prices['shipmentPrice'] = $product->prices['shipmentPrice'] * (1 + $rule[1]/100.0);
//						}
//					}
//
//					$html[$this->_currentMethod->virtuemart_shipmentmethod_id] = $this->renderByLayout( 'default', array("method" => $this->_currentMethod, "cart" => $cart,"product" => $product,"currency" => $currency) );
//				}
//			}
//		}
//		if(isset($cart)){
//			unset($cart->products['virtual']);
//			$cart->_productAdded = true;
//			$cart->prepareCartData();
//		}
//
//
//		$productDisplayShipments[] = $html;

	}

	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 *
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallShipmentPluginTable ($jplugin_id) {

		return $this->onStoreInstallPluginTable ($jplugin_id);
	}

	/**
	 * @param VirtueMartCart $cart
	 * @return null
	 */
//	public function plgVmOnSelectCheckShipment (VirtueMartCart &$cart) {
//		return $this->OnSelectCheck ($cart);
//	}

	/**
	 * plgVmDisplayListFE
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for example
	 *
	 * @param object  $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on success, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEShipment (VirtueMartCart $cart, $selected = 0, &$htmlIn) {




        return $this->displayListFE ($cart, $selected, $htmlIn);
	}



    protected function getPluginHtml ($plugin, $selectedPlugin, $pluginSalesPrice) {

        $currency = CurrencyDisplay::getInstance ();

        $input = array('plugin' => $plugin,
            'psType'=>$this->_psType,
            'selectedPlugin' => $selectedPlugin,
            'pluginSalesPrice' => $pluginSalesPrice,
            'currency'=>$currency
        );


        $typeUnLoad = $this->getConfigShipmentMethod($plugin->virtuemart_shipmentmethod_id)['is_goods_unloading'];
        $html = shopFunctionsF::renderVmSubLayout('methodprices', $input).'<br/>';

        if($typeUnLoad != '1'){

            $html .= '<span>Терминалы доступные для доставки:</span>';
            $html .= '<select id="order_terminal_id" name="order_terminal_id">';

            foreach ($_SESSION['current_terminals'] as $terminal){
                $html .= '<option value="'.$terminal->id.'" >'.$terminal->name.' '.$terminal->address.'</option>';
            }

            $html .= '</select>';

        }

        return $html;

    }






    /**
	 * @param VirtueMartCart $cart
	 * @param array          $cart_prices
	 * @param                $cart_prices_name
	 * @return bool|null
	 */
	public function plgVmOnSelectedCalculatePriceShipment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
	}





	/**
	 * plgVmOnCheckAutomaticSelected
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 *
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedShipment (VirtueMartCart $cart, array $cart_prices, &$shipCounter) {
		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $shipCounter);
	}

//	function plgVmOnCheckoutCheckDataShipment(VirtueMartCart $cart){
//		if(empty($cart->virtuemart_shipmentmethod_id)) return false;
//
//		if ($this->getPluginMethods($cart->vendorId) === 0) {
//			return NULL;
//		}
//
//		foreach ($this->methods as $this->_currentMethod) {
//			if($cart->virtuemart_shipmentmethod_id == $this->_currentMethod->virtuemart_shipmentmethod_id){
//				if(!$this->checkConditions($cart,$this->_currentMethod,$cart->cartPrices)){
//					return false;
//				}
//				break;
//			}
//		}
//	}

	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrint ($order_number, $method_id) {
		return $this->onShowOrderPrint ($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsShipment ($name, $id, &$dataOld) {

		return $this->declarePluginParams ('shipment', $name, $id, $dataOld);
	}

	function plgVmDeclarePluginParamsShipmentVM3 (&$data) {
		return $this->declarePluginParams ('shipment', $data);
	}


	/**
	 * @author Max Milbers
	 * @param $data
	 * @param $table
	 * @return bool
	 */
	function plgVmSetOnTablePluginShipment(&$data,&$table){

		$name = $data['shipment_element'];
		$id = $data['shipment_jplugin_id'];

		if (!empty($this->_psType) and !$this->selectedThis ($this->_psType, $name, $id)) {
			return FALSE;
		} else {
			$tCon = array('weight_start','weight_stop','min_amount','max_amount','shipment_cost','package_fee');
			foreach($tCon as $f){
				if(!empty($data[$f])){
					$data[$f] = str_replace(array(',',' '),array('.',''),$data[$f]);
				}
			}

			$data['nbproducts_start'] = (int) $data['nbproducts_start'];
			$data['nbproducts_stop'] = (int) $data['nbproducts_stop'];

			//Reasonable tests:
			if(!empty($data['zip_start']) and !empty($data['zip_stop']) and (int)$data['zip_start']>=(int)$data['zip_stop']){
				vmWarn('VMSHIPMENT_WEIGHT_COUNTRIES_ZIP_CONDITION_WRONG');
			}
			if(!empty($data['weight_start']) and !empty($data['weight_stop']) and (float)$data['weight_start']>=(float)$data['weight_stop']){
				vmWarn('VMSHIPMENT_WEIGHT_COUNTRIES_WEIGHT_CONDITION_WRONG');
			}

			if(!empty($data['min_order']) and !empty($data['max_order']) and (float)$data['min_order']>=(float)$data['max_order']){
				vmWarn('VMSHIPMENT_WEIGHT_COUNTRIES_AMOUNT_CONDITION_WRONG');
			}

			if(!empty($data['nbproducts_start']) and !empty($data['nbproducts_stop']) and (float)$data['nbproducts_start']>=(float)$data['nbproducts_stop']){
				vmWarn('VMSHIPMENT_WEIGHT_COUNTRIES_NBPRODUCTS_CONDITION_WRONG');
			}

			//$data['orderamount_start'] = $data['min_amount'];
			//$data['orderamount_stop'] = $data['max_amount'];

			//$data['show_on_pdetails'] = (int) $data['show_on_pdetails'];
			return $this->setOnTablePluginParams ($name, $id, $table);
		}
	}


}

// No closing tag
